static const struct key_name_entry {
  int key;                  ///< Special key code or ascii value
  String name;              ///< Name of key
  const String *pref_name;  ///< Pointer to preferred key name
                            ///< (may be NULL or point to the name in another entry)
} key_names_table[] = {
  {K_K0, {"k0", 2}, NULL},
  {K_F1, {"F1", 2}, NULL},
  {K_K1, {"k1", 2}, NULL},
  {K_F2, {"F2", 2}, NULL},
  {K_K2, {"k2", 2}, NULL},
  {K_F3, {"F3", 2}, NULL},
  {K_K3, {"k3", 2}, NULL},
  {K_F4, {"F4", 2}, NULL},
  {K_K4, {"k4", 2}, NULL},
  {K_F5, {"F5", 2}, NULL},
  {K_K5, {"k5", 2}, NULL},
  {K_F6, {"F6", 2}, NULL},
  {K_K6, {"k6", 2}, NULL},
  {K_F7, {"F7", 2}, NULL},
  {K_K7, {"k7", 2}, NULL},
  {K_F8, {"F8", 2}, NULL},
  {K_K8, {"k8", 2}, NULL},
  {K_F9, {"F9", 2}, NULL},
  {K_K9, {"k9", 2}, NULL},
  {NL, {"LF", 2}, &key_names_table[20].name},
  {NL, {"NL", 2}, NULL},
  {K_UP, {"Up", 2}, NULL},
  {CAR, {"CR", 2}, NULL},
  {K_BS, {"BS", 2}, NULL},
  {'<', {"lt", 2}, NULL},
  {K_F10, {"F10", 3}, NULL},
  {K_F20, {"F20", 3}, NULL},
  {K_F30, {"F30", 3}, NULL},
  {K_F40, {"F40", 3}, NULL},
  {K_F50, {"F50", 3}, NULL},
  {K_F60, {"F60", 3}, NULL},
  {K_KINS, {"KP0", 3}, &key_names_table[157].name},
  {K_F11, {"F11", 3}, NULL},
  {K_F21, {"F21", 3}, NULL},
  {K_F31, {"F31", 3}, NULL},
  {K_F41, {"F41", 3}, NULL},
  {K_F51, {"F51", 3}, NULL},
  {K_F61, {"F61", 3}, NULL},
  {K_KEND, {"KP1", 3}, &key_names_table[112].name},
  {K_XF1, {"xF1", 3}, NULL},
  {K_F12, {"F12", 3}, NULL},
  {K_F22, {"F22", 3}, NULL},
  {K_F32, {"F32", 3}, NULL},
  {K_F42, {"F42", 3}, NULL},
  {K_F52, {"F52", 3}, NULL},
  {K_F62, {"F62", 3}, NULL},
  {K_KDOWN, {"KP2", 3}, &key_names_table[118].name},
  {K_XF2, {"xF2", 3}, NULL},
  {K_F13, {"F13", 3}, NULL},
  {K_F23, {"F23", 3}, NULL},
  {K_F33, {"F33", 3}, NULL},
  {K_F43, {"F43", 3}, NULL},
  {K_F53, {"F53", 3}, NULL},
  {K_F63, {"F63", 3}, NULL},
  {K_KPAGEDOWN, {"KP3", 3}, &key_names_table[168].name},
  {K_XF3, {"xF3", 3}, NULL},
  {K_F14, {"F14", 3}, NULL},
  {K_F24, {"F24", 3}, NULL},
  {K_F34, {"F34", 3}, NULL},
  {K_F44, {"F44", 3}, NULL},
  {K_F54, {"F54", 3}, NULL},
  {K_KLEFT, {"KP4", 3}, &key_names_table[124].name},
  {K_XF4, {"xF4", 3}, NULL},
  {K_F15, {"F15", 3}, NULL},
  {K_F25, {"F25", 3}, NULL},
  {K_F35, {"F35", 3}, NULL},
  {K_F45, {"F45", 3}, NULL},
  {K_F55, {"F55", 3}, NULL},
  {K_KORIGIN, {"KP5", 3}, &key_names_table[158].name},
  {K_F16, {"F16", 3}, NULL},
  {K_F26, {"F26", 3}, NULL},
  {K_F36, {"F36", 3}, NULL},
  {K_F46, {"F46", 3}, NULL},
  {K_F56, {"F56", 3}, NULL},
  {K_KRIGHT, {"KP6", 3}, &key_names_table[136].name},
  {K_F17, {"F17", 3}, NULL},
  {K_F27, {"F27", 3}, NULL},
  {K_F37, {"F37", 3}, NULL},
  {K_F47, {"F47", 3}, NULL},
  {K_F57, {"F57", 3}, NULL},
  {K_KHOME, {"KP7", 3}, &key_names_table[120].name},
  {K_F18, {"F18", 3}, NULL},
  {K_F28, {"F28", 3}, NULL},
  {K_F38, {"F38", 3}, NULL},
  {K_F48, {"F48", 3}, NULL},
  {K_F58, {"F58", 3}, NULL},
  {K_KUP, {"KP8", 3}, &key_names_table[101].name},
  {K_F19, {"F19", 3}, NULL},
  {K_F29, {"F29", 3}, NULL},
  {K_F39, {"F39", 3}, NULL},
  {K_F49, {"F49", 3}, NULL},
  {K_F59, {"F59", 3}, NULL},
  {K_KPAGEUP, {"KP9", 3}, &key_names_table[150].name},
  {TAB, {"Tab", 3}, NULL},
  {K_TAB, {"Tab", 3}, NULL},
  {ESC, {"Esc", 3}, NULL},
  {K_COMMAND, {"Cmd", 3}, NULL},
  {K_END, {"End", 3}, NULL},
  {CSI, {"CSI", 3}, NULL},
  {K_DEL, {"Del", 3}, NULL},
  {K_ZERO, {"Nul", 3}, NULL},
  {K_KUP, {"kUp", 3}, NULL},
  {K_XUP, {"xUp", 3}, NULL},
  {'|', {"Bar", 3}, NULL},
  {K_SNR, {"SNR", 3}, NULL},
  {K_INS, {"Ins", 3}, &key_names_table[148].name},
  {K_DOWN, {"Down", 4}, NULL},
  {K_DROP, {"Drop", 4}, NULL},
  {K_FIND, {"Find", 4}, NULL},
  {K_HELP, {"Help", 4}, NULL},
  {K_HOME, {"Home", 4}, NULL},
  {K_KDEL, {"kDel", 4}, NULL},
  {K_KEND, {"kEnd", 4}, NULL},
  {K_LEFT, {"Left", 4}, NULL},
  {K_PLUG, {"Plug", 4}, NULL},
  {K_UNDO, {"Undo", 4}, NULL},
  {K_XEND, {"xEnd", 4}, NULL},
  {K_ZEND, {"zEnd", 4}, NULL},
  {K_KDOWN, {"kDown", 5}, NULL},
  {K_XDOWN, {"xDown", 5}, NULL},
  {K_KHOME, {"kHome", 5}, NULL},
  {K_XHOME, {"xHome", 5}, NULL},
  {K_ZHOME, {"zHome", 5}, NULL},
  {K_RIGHT, {"Right", 5}, NULL},
  {K_KLEFT, {"kLeft", 5}, NULL},
  {K_XLEFT, {"xLeft", 5}, NULL},
  {CAR, {"Enter", 5}, &key_names_table[22].name},
  {K_MOUSE, {"Mouse", 5}, NULL},
  {K_KDIVIDE, {"KPDiv", 5}, &key_names_table[153].name},
  {K_KPLUS, {"kPlus", 5}, NULL},
  {' ', {"Space", 5}, NULL},
  {ESC, {"Escape", 6}, &key_names_table[95].name},
  {K_X1DRAG, {"X1Drag", 6}, NULL},
  {K_X2DRAG, {"X2Drag", 6}, NULL},
  {K_PAGEUP, {"PageUp", 6}, NULL},
  {K_KMINUS, {"kMinus", 6}, NULL},
  {K_KRIGHT, {"kRight", 6}, NULL},
  {K_XRIGHT, {"xRight", 6}, NULL},
  {'\\', {"Bslash", 6}, NULL},
  {K_DEL, {"Delete", 6}, &key_names_table[99].name},
  {K_KSELECT, {"Select", 6}, NULL},
  {K_KMULTIPLY, {"KPMult", 6}, &key_names_table[167].name},
  {K_IGNORE, {"Ignore", 6}, NULL},
  {K_KENTER, {"kEnter", 6}, NULL},
  {K_KCOMMA, {"kComma", 6}, NULL},
  {K_KPOINT, {"kPoint", 6}, NULL},
  {K_KPLUS, {"KPPlus", 6}, &key_names_table[129].name},
  {K_KEQUAL, {"kEqual", 6}, NULL},
  {K_INS, {"Insert", 6}, NULL},
  {CAR, {"Return", 6}, &key_names_table[22].name},
  {K_KPAGEUP, {"kPageUp", 7}, NULL},
  {K_KCOMMA, {"KPComma", 7}, &key_names_table[144].name},
  {K_KENTER, {"KPEnter", 7}, &key_names_table[143].name},
  {K_KDIVIDE, {"kDivide", 7}, NULL},
  {K_KMINUS, {"KPMinus", 7}, &key_names_table[135].name},
  {K_X1MOUSE, {"X1Mouse", 7}, NULL},
  {K_X2MOUSE, {"X2Mouse", 7}, NULL},
  {K_KINS, {"kInsert", 7}, NULL},
  {K_KORIGIN, {"kOrigin", 7}, NULL},
  {K_MOUSEUP, {"MouseUp", 7}, &key_names_table[184].name},
  {NL, {"NewLine", 7}, &key_names_table[20].name},
  {K_KEQUAL, {"KPEquals", 8}, &key_names_table[147].name},
  {K_LEFTDRAG, {"LeftDrag", 8}, NULL},
  {K_PAGEDOWN, {"PageDown", 8}, NULL},
  {NL, {"LineFeed", 8}, &key_names_table[20].name},
  {K_KDEL, {"KPPeriod", 8}, &key_names_table[111].name},
  {K_BS, {"BackSpace", 9}, &key_names_table[23].name},
  {K_KMULTIPLY, {"kMultiply", 9}, NULL},
  {K_KPAGEDOWN, {"kPageDown", 9}, NULL},
  {K_LEFTMOUSE, {"LeftMouse", 9}, NULL},
  {K_MOUSEDOWN, {"MouseDown", 9}, &key_names_table[183].name},
  {K_MOUSEMOVE, {"MouseMove", 9}, NULL},
  {K_RIGHTDRAG, {"RightDrag", 9}, NULL},
  {K_X1RELEASE, {"X1Release", 9}, NULL},
  {K_X2RELEASE, {"X2Release", 9}, NULL},
  {K_MIDDLEDRAG, {"MiddleDrag", 10}, NULL},
  {K_RIGHTMOUSE, {"RightMouse", 10}, NULL},
  {K_MIDDLEMOUSE, {"MiddleMouse", 11}, NULL},
  {K_LEFTMOUSE_NM, {"LeftMouseNM", 11}, NULL},
  {K_LEFTRELEASE, {"LeftRelease", 11}, NULL},
  {K_RIGHTRELEASE, {"RightRelease", 12}, NULL},
  {K_LEFTRELEASE_NM, {"LeftReleaseNM", 13}, NULL},
  {K_MIDDLERELEASE, {"MiddleRelease", 13}, NULL},
  {K_MOUSEDOWN, {"ScrollWheelUp", 13}, NULL},
  {K_MOUSEUP, {"ScrollWheelDown", 15}, NULL},
  {K_MOUSERIGHT, {"ScrollWheelLeft", 15}, NULL},
  {K_MOUSELEFT, {"ScrollWheelRight", 16}, NULL},
};

static int get_special_key_code_hash(const char *str, size_t len)
{
  int low = 0, high = 0;
  switch (len) {
    case 2: switch (str[1]) {
      case '0': low = 0; high = 1; break;
      case '1': low = 1; high = 3; break;
      case '2': low = 3; high = 5; break;
      case '3': low = 5; high = 7; break;
      case '4': low = 7; high = 9; break;
      case '5': low = 9; high = 11; break;
      case '6': low = 11; high = 13; break;
      case '7': low = 13; high = 15; break;
      case '8': low = 15; high = 17; break;
      case '9': low = 17; high = 19; break;
      case 'F': case 'f': low = 19; high = 20; break;
      case 'L': case 'l': low = 20; high = 21; break;
      case 'P': case 'p': low = 21; high = 22; break;
      case 'R': case 'r': low = 22; high = 23; break;
      case 'S': case 's': low = 23; high = 24; break;
      case 'T': case 't': low = 24; high = 25; break;
      default: break;
    }
    break;
    case 3: switch (str[2]) {
      case '0': low = 25; high = 32; break;
      case '1': low = 32; high = 40; break;
      case '2': low = 40; high = 48; break;
      case '3': low = 48; high = 56; break;
      case '4': low = 56; high = 63; break;
      case '5': low = 63; high = 69; break;
      case '6': low = 69; high = 75; break;
      case '7': low = 75; high = 81; break;
      case '8': low = 81; high = 87; break;
      case '9': low = 87; high = 93; break;
      case 'B': case 'b': low = 93; high = 95; break;
      case 'C': case 'c': low = 95; high = 96; break;
      case 'D': case 'd': low = 96; high = 98; break;
      case 'I': case 'i': low = 98; high = 99; break;
      case 'L': case 'l': low = 99; high = 101; break;
      case 'P': case 'p': low = 101; high = 103; break;
      case 'R': case 'r': low = 103; high = 105; break;
      case 'S': case 's': low = 105; high = 106; break;
      default: break;
    }
    break;
    case 4: switch (str[0]) {
      case 'D': case 'd': low = 106; high = 108; break;
      case 'F': case 'f': low = 108; high = 109; break;
      case 'H': case 'h': low = 109; high = 111; break;
      case 'K': case 'k': low = 111; high = 113; break;
      case 'L': case 'l': low = 113; high = 114; break;
      case 'P': case 'p': low = 114; high = 115; break;
      case 'U': case 'u': low = 115; high = 116; break;
      case 'X': case 'x': low = 116; high = 117; break;
      case 'Z': case 'z': low = 117; high = 118; break;
      default: break;
    }
    break;
    case 5: switch (str[1]) {
      case 'D': case 'd': low = 118; high = 120; break;
      case 'H': case 'h': low = 120; high = 123; break;
      case 'I': case 'i': low = 123; high = 124; break;
      case 'L': case 'l': low = 124; high = 126; break;
      case 'N': case 'n': low = 126; high = 127; break;
      case 'O': case 'o': low = 127; high = 128; break;
      case 'P': case 'p': low = 128; high = 131; break;
      default: break;
    }
    break;
    case 6: switch (str[2]) {
      case 'C': case 'c': low = 131; high = 132; break;
      case 'D': case 'd': low = 132; high = 134; break;
      case 'G': case 'g': low = 134; high = 135; break;
      case 'I': case 'i': low = 135; high = 138; break;
      case 'L': case 'l': low = 138; high = 141; break;
      case 'M': case 'm': low = 141; high = 142; break;
      case 'N': case 'n': low = 142; high = 144; break;
      case 'O': case 'o': low = 144; high = 146; break;
      case 'P': case 'p': low = 146; high = 147; break;
      case 'Q': case 'q': low = 147; high = 148; break;
      case 'S': case 's': low = 148; high = 149; break;
      case 'T': case 't': low = 149; high = 150; break;
      default: break;
    }
    break;
    case 7: switch (str[2]) {
      case 'A': case 'a': low = 150; high = 151; break;
      case 'C': case 'c': low = 151; high = 152; break;
      case 'E': case 'e': low = 152; high = 153; break;
      case 'I': case 'i': low = 153; high = 154; break;
      case 'M': case 'm': low = 154; high = 157; break;
      case 'N': case 'n': low = 157; high = 158; break;
      case 'R': case 'r': low = 158; high = 159; break;
      case 'U': case 'u': low = 159; high = 160; break;
      case 'W': case 'w': low = 160; high = 161; break;
      default: break;
    }
    break;
    case 8: switch (str[2]) {
      case 'E': case 'e': low = 161; high = 162; break;
      case 'F': case 'f': low = 162; high = 163; break;
      case 'G': case 'g': low = 163; high = 164; break;
      case 'N': case 'n': low = 164; high = 165; break;
      case 'P': case 'p': low = 165; high = 166; break;
      default: break;
    }
    break;
    case 9: switch (str[0]) {
      case 'B': case 'b': low = 166; high = 167; break;
      case 'K': case 'k': low = 167; high = 169; break;
      case 'L': case 'l': low = 169; high = 170; break;
      case 'M': case 'm': low = 170; high = 172; break;
      case 'R': case 'r': low = 172; high = 173; break;
      case 'X': case 'x': low = 173; high = 175; break;
      default: break;
    }
    break;
    case 10: switch (str[0]) {
      case 'M': case 'm': low = 175; high = 176; break;
      case 'R': case 'r': low = 176; high = 177; break;
      default: break;
    }
    break;
    case 11: switch (str[4]) {
      case 'L': case 'l': low = 177; high = 178; break;
      case 'M': case 'm': low = 178; high = 179; break;
      case 'R': case 'r': low = 179; high = 180; break;
      default: break;
    }
    break;
    case 12: low = 180; high = 181; break;
    case 13: switch (str[0]) {
      case 'L': case 'l': low = 181; high = 182; break;
      case 'M': case 'm': low = 182; high = 183; break;
      case 'S': case 's': low = 183; high = 184; break;
      default: break;
    }
    break;
    case 15: switch (str[11]) {
      case 'D': case 'd': low = 184; high = 185; break;
      case 'L': case 'l': low = 185; high = 186; break;
      default: break;
    }
    break;
    case 16: low = 186; high = 187; break;
    default: break;
  }
  for (int i = low; i < high; i++) {
    if (!vim_strnicmp_asc(str, key_names_table[i].name.data, len)) {
      return i;
    }
  }
  return -1;
}

